#Include Once "md/util/logging/mdLogger.bi"
#Include Once "md/lang/mdException.bi"

Dim As mdLogger logger = mdLogger.getLogger("This")

#Include Once "md/util/logging/mdFileHandler.bi"
Dim As mdFileHandler fileHandler = ExePath & "\stdout.log"

#Include Once "md/util/logging/mdXMLFormatter.bi"
Dim As mdXMLFormatter xmlFormatter
fileHandler.setFormatter(xmlFormatter)

logger.addHandler(fileHandler)

#Include Once "md/util/logging/mdConsoleHandler.bi"
Dim As mdConsoleHandler consoleHandler
logger.addHandler(consoleHandler)

#Include Once "mdTestFilter.bi"
Dim As mdTestFilter testFilter
'logger.setFilter(testFilter) 'mdTestFilter just allow mdLevel.INFO to show up

logger.log(mdLevel.SEVERE, "Hello logging: {0}", "P1")

'12-24-2013 14:45:12 logging.LoggingExamples main
'INFO: Hello logging: P1

Dim As String array(0 To ...) = {"P1", "P2"}
logger.log(mdLevel.SEVERE, "Hello logging: {0}, {1}", array())

'12-24-2013 14:45:12 logging.LoggingExamples main
'SEVERE: Hello logging: P1, P2

logger.log(mdLevel.SEVERE, "Hello logging", Type<mdException>("Error"))

'12-24-2013 14:54:29 logging.LoggingExamples main
'SEVERE: Hello logging
'java.lang.RuntimeException: Error
'	at logging.LoggingExamples.main(LoggingExamples.java:18)

Sleep
