'mdObject - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/lang/Object.html


#Ifndef MODULE_SCOPE
	#Define MODULE_SCOPE Private
#EndIf

#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf


#Ifndef __MDOBJECT_BI__
#Define __MDOBJECT_BI__

Type mdObject Extends Object
	Public:
	Declare Virtual Function equals(ByRef obj As mdObject) As Boolean
	'Declare Virtual Function getClass() As mdClass(?)
	Declare Virtual Function getClass() As String
	Declare Virtual Function hashCode() As Integer
	'Declare Virtual Sub notify()
	'Declare Virtual Sub notifyAll()
	Declare Virtual Function toString() As String 
	'Declare Virtual Sub wait()
	'Declare Virtual Sub wait(timeout As Long)
	'Declare Virtual Sub wait(timeout As Long, nanos As Integer)
	
	Protected:
	Declare Virtual Function clone() As mdObject
	'Declare Virtual Sub finalize()
End Type

MODULE_SCOPE Function mdObject.equals(ByRef obj As mdObject) As Boolean
	Return @This = @obj
End Function

'MODULE_SCOPE Function mdObject.getClass() As mdClass(?)
'	
'End Function

MODULE_SCOPE Function mdObject.getClass() As String
	Dim As ZString Ptr pz = Cast(Any Ptr Ptr Ptr Ptr, @This)[0][-1][1]
	While (*pz)[0] >= Asc("0") AndAlso (*pz)[0] <= Asc("9")
		pz += 1
	Wend
	Return *pz
End Function

MODULE_SCOPE Function mdObject.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

'MODULE_SCOPE Sub mdObject.notify()
'	
'End Sub
'
'MODULE_SCOPE Sub mdObject.notifyAll()
'	
'End Sub

MODULE_SCOPE Function mdObject.toString() As String 
	Return This.getClass() & "@" & @This
End Function

'MODULE_SCOPE Sub mdObject.wait()
'	
'End Sub
'
'MODULE_SCOPE Sub mdObject.wait(timeout As Long)
'	
'End Sub
'
'MODULE_SCOPE Sub mdObject.wait(timeout As Long, nanos As Integer)
'	
'End Sub

MODULE_SCOPE Function mdObject.clone() As mdObject
	Return This
End Function

'MODULE_SCOPE Sub mdObject.finalize()
'	
'End Sub

#EndIf '__MDOBJECT_BI__
