'mdErrorManager - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/ErrorManager.html


#Include Once "md/lang/mdObject.bi"
#Include Once "md/lang/mdException.bi"


#Ifndef __MDERRORMANAGER_BI__
#Define __MDERRORMANAGER_BI__

Type mdErrorManager Extends mdObject
	Public:
	Declare Constructor ()
	
	Declare Virtual Sub error(ByRef msg As String, ByRef ex As mdException, ByVal code As Integer)
	
	Static As Const Integer CLOSE_FAILURE
	Static As Const Integer FLUSH_FAILURE
	Static As Const Integer FORMAT_FAILURE
	Static As Const Integer GENERIC_FAILURE
	Static As Const Integer OPEN_FAILURE
	Static As Const Integer WRITE_FAILURE
End Type

MODULE_SCOPE Constructor mdErrorManager()
	
End Constructor

MODULE_SCOPE Sub mdErrorManager.error(ByRef msg As String, ByRef ex As mdException, ByVal code As Integer)
	Print "mdErrorManager: " & code & ": " & msg
	ex.printStackTrace()
End Sub

Dim As Const Integer mdErrorManager.CLOSE_FAILURE = 3
Dim As Const Integer mdErrorManager.FLUSH_FAILURE = 2
Dim As Const Integer mdErrorManager.FORMAT_FAILURE = 5
Dim As Const Integer mdErrorManager.GENERIC_FAILURE = 0
Dim As Const Integer mdErrorManager.OPEN_FAILURE = 4
Dim As Const Integer mdErrorManager.WRITE_FAILURE = 1

#EndIf '__MDERRORMANAGER_BI__
