#Include Once "md/persistence/mdSQLitePersistence.bi"

'Persisted classes
Type MyFoo
	Declare Constructor ()
	Declare Constructor (ByRef newObject As mdMap(String, String))
	
	Declare Operator Cast() As String
	
	As Integer id
	As String description
End Type

Constructor MyFoo()
	
End Constructor

Constructor MyFoo(ByRef newObject As mdMap(String, String))
	This.id = ValInt(newObject.get("id"))
	This.description = newObject.get("description")
End Constructor

Operator MyFoo.Cast() As String
	Return "{id=" & This.id & ", description=" & This.description & "}"
End Operator

Operator = (ByRef lhs As MyFoo, ByRef rhs As MyFoo) As Boolean
	Return Str(lhs) = Str(rhs)
End Operator

Type MyBar
	Declare Constructor ()
	Declare Constructor (ByRef newObject As mdMap(String, String))
	
	Declare Operator Cast() As String
	
	As Integer id
	As Double value
	As Boolean isImportant
End Type

Constructor MyBar()
	
End Constructor

Constructor MyBar(ByRef newObject As mdMap(String, String))
	This.id = ValInt(newObject.get("id"))
	This.value = Val(newObject.get("value"))
	This.isImportant = ValInt(newObject.get("isImportant"))
End Constructor

Operator MyBar.Cast() As String
	Return "{id=" & This.id & ", value=" & This.value & ", isImportant=" & This.isImportant & "}"
End Operator

Operator = (ByRef lhs As MyBar, ByRef rhs As MyBar) As Boolean
	Return Str(lhs) = Str(rhs)
End Operator

Dim As MyFoo tempFoo
Dim As MyBar tempBar

Dim As String temp
Dim As mdMap(String, String) tables
temp = tables.put("MyFoo", tempFoo)
temp = tables.put("MyBar", tempBar)

Dim As mdSQLitePersistence sql

sql.createDatabase("MyApplicationDB", tables)

'Print sql.query("select * from sqlite_master where type='table';")
'Print _mdSQLitePersistence_resultList_
'Sleep
'
'tables.clear()
'temp = tables.put("MyFoo", tempFoo)
'temp = tables.put("MyBar", tempFoo)
'Print sql.updateDatabase("MyApplicationDB", tables)
'Print sql.query("select * from sqlite_master where type='table';")
'Print _mdSQLitePersistence_resultList_
'
'
'
'Sleep
'sql.removeDatabase("MyApplicationDB")
'End



tempFoo.id = 1
tempFoo.description = "1"
sql.createObject("MyFoo", tempFoo)

tempFoo.id = 2
tempFoo.description = "2"
sql.createObject("MyFoo", tempFoo)
tempFoo.id = 2
tempFoo.description = "22"
sql.createObject("MyFoo", tempFoo)

Dim As mdList(mdMapStringString) resultList = sql.getObjectsBy("MyFoo", "id", "2")
Print resultList, sql.getLastErrorMessage()

'sql.deleteAllObjects("MyFoo")

Dim As MyFoo updatedFoo
updatedFoo.id = 2
updatedFoo.description = "UPDATED"
sql.updateObjectsBy("MyFoo", "id", "2", updatedFoo)
resultList = sql.getObjectsBy("MyFoo", "id", "2")
Print resultList, sql.getLastErrorMessage()

Dim As MyFoo updatedFoo2
updatedFoo2.id = 2
updatedFoo2.description = "UPDATED 2"
sql.updateObject("MyFoo", updatedFoo, updatedFoo2)
resultList = sql.getObjectsBy("MyFoo", "id", "2")
Print resultList, sql.getLastErrorMessage()

sql.deleteObjectsBy("MyFoo", "id", "2")
resultList = sql.getObjectsBy("MyFoo", "id", "2")
Print resultList, sql.getLastErrorMessage()

resultList = sql.getObjectsBy("MyFoo", "id", "1")
Print resultList, sql.getLastErrorMessage()

Dim As MyFoo fooToDelete
fooToDelete.id = 1
fooToDelete.description = "1"
sql.deleteObject("MyFoo", fooToDelete)

resultList = sql.getObjectsBy("MyFoo", "id", "1")
Print resultList, sql.getLastErrorMessage()


Sleep
sql.removeDatabase("MyApplicationDB")

