'mdTryCatch - by MOD


'no Java representation
'compile with -e, -ex or -exx


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Ifndef NEWLINE
	#If Defined(__FB_WIN32__)
		#Define NEWLINE !"\r\n"
	#ElseIf Defined(__FB_LINUX__)
		#Define NEWLINE !"\n"
	#EndIf
#EndIf


#Ifndef __MDTRYCATCH_BI__
#Define __MDTRYCATCH_BI__

Dim Shared As ZString Ptr FB_ERRORS(0 To ...) = { _
												@"No error", _							'  0
												@"Illegal function call", _				'  1
												@"File not found signal", _				'  2
												@"File I/O error", _					'  3
												@"Out of memory", _						'  4
												@"Illegal resume", _					'  5
												@"Out of bounds array access", _		'  6
												@"Null Pointer Access", _				'  7
												@"No privileges", _						'  8
												@"interrupted signal", _				'  9
												@"illegal instruction signal", _		'  10
												@"floating point error signal", _		'  11
												@"segmentation violation signal", _		'  12
												@"Termination request signal", _		'  13
												@"abnormal termination signal", _		'  14
												@"quit request signal", _				'  15
												@"return without gosub", _				'  16
												@"end of file" _						'  17
											}

#Define Try(N) On Error GoTo N : Scope
#Define Catch(N) N: Dim As Integer N##_ERROR = Err : If N##_ERROR <> 0 Then
#Define EndCatch EndIf : On Error GoTo 0
#Define Finally(N)
#Define EndFinally
#Define EndTry End Scope
#Define Throw(N) Error CInt(N)
#Define TraceException(N) "Exception in " & *Ermn & " at " & *Erfn & "(" & Erl & "):" & NEWLINE & IIf(N <= UBound(FB_ERRORS), *FB_ERRORS(N), Cast(mdException Ptr, N)->getStackTrace())

#EndIf '__MDTRYCATCH_BI__
