'mdHashtable - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Hashtable.html


#Include Once "md/util/mdDictionary.bi"

#Define mdHashtablePtr(K, PK, V, PV) mdHashtable##K##PK##V##PV
#Define mdHashtable(K, V) mdHashtablePtr(K, , V, )

#Macro mdHashtableDeclarePtrPtr(K, PK, V, PV)

mdDictionaryDeclarePtr(K, PK, V, PV)
mdEnumerationDeclarePtr(V, PV)

#Ifndef mdHashtable##K##PK##V##PV
'#Define __MDHASHTABLE_BI__

Type mdHashtable##K##PK##V##PV Extends mdDictionary##K##PK##V##PV
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef m As mdHashtable##K##PK##V##PV)
	Declare Virtual Destructor ()
	
	Declare Virtual Function getClass() As String
	
	Declare Virtual Operator Cast() As Integer
	Declare Virtual Operator Cast() As String
	Declare Virtual Operator Let(ByRef c As mdHashtable##K##PK##V##PV)
	
#If __FB_MIN_VERSION__(0, 91, 0)
	Declare Virtual Operator [](ByVal key As K PK) ByRef As V PV
#EndIf
End Type

MODULE_SCOPE Constructor mdHashtable##K##PK##V##PV()
	
End Constructor

MODULE_SCOPE Constructor mdHashtable##K##PK##V##PV(ByRef m As mdHashtable##K##PK##V##PV)
	This.putAll(m)
End Constructor

MODULE_SCOPE Destructor mdHashtable##K##PK##V##PV()
	This.clear()
End Destructor

MODULE_SCOPE Function mdHashtable##K##PK##V##PV.getClass() As String
	Return UCase("mdHashtable(" & #K & ", " & IIf(Len(#PK) OrElse Len(#PV), #PK, #V) & IIf(Len(#PK) OrElse Len(#PV), ", " & #V & ", " & #PV, "") & ")")
End Function

MODULE_SCOPE Operator mdHashtable##K##PK##V##PV.Cast() As Integer
	Return This.hashCode()
End Operator

MODULE_SCOPE Operator mdHashtable##K##PK##V##PV.Cast() As String
	Return This.toString()
End Operator

MODULE_SCOPE Operator mdHashtable##K##PK##V##PV.Let(ByRef c As mdHashtable##K##PK##V##PV)
	This.clear()
	This.putAll(c)
End Operator

#If __FB_MIN_VERSION__(0, 91, 0)
MODULE_SCOPE Operator mdHashtable##K##PK##V##PV.[](ByVal key As K PK) ByRef As V PV
	Dim As mdMapNode##K##PK##V##PV Ptr currentNode = This.node
	While currentNode <> NULL
		If currentNode->value.getKey() = key Then
			Return currentNode->value[key]
		EndIf
		currentNode = currentNode->nex
	Wend
	Dim As mdMapNode##K##PK##V##PV Ptr emptyValue
	Return emptyValue->value[key]
End Operator
#EndIf

MODULE_SCOPE Operator = (ByRef lhs As mdHashtable##K##PK##V##PV, ByRef rhs As mdHashtable##K##PK##V##PV) As Boolean
	Return lhs.toString() = rhs.toString()
End Operator

#EndIf '__MDHASHTABLE_BI__

#EndMacro

#Define mdHashtableDeclare(K, V) mdHashtableDeclarePtrPtr(K, , V, )
#Define mdHashtableDeclarePtr(K, PK, V, PV) mdHashtableDeclarePtrPtr(K, PK, V, PV)
