'mdIterator - by MOD

'http://docs.oracle.com/javase/6/docs/api/java/util/Iterator.html


#Include Once "md/lang/mdObject.bi"

#Macro ForEachPtr(T, var_, object_, P)
	Scope
	Dim As mdIterator##T##P var_##mdIterator##T##P = object_.iterator()
	While var_##mdIterator##T##P.hasNext()
		var_ = var_##mdIterator##T##P.nex()
#EndMacro
#Define ForEach(T, var_, object_, P...) ForEachPtr(T, var_, object_, P)

#Define ContinueEach Continue While
#Define ExitEach Exit While

#Ifndef In
	#Define In ,
	#Define NextEach Wend : End Scope
#EndIf

#Define mdIteratorPtr(E, P) mdIterator##E##P
#Define mdIterator(E, P...) mdIteratorPtr(E, P)

#Macro mdIteratorDeclarePtr(E, P)

#Ifndef mdIterator##E##P
'#Define __MDITERATOR_BI__

Type mdIterator##E##P Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByVal node As mdBasicNode##E##P Ptr)
	
	Declare Virtual Function getClass() As String
	Declare Virtual Function hasNext() As Boolean
	Declare Virtual Function nex() As E P
	Declare Virtual Sub remove()
	
	Protected:
	pre As mdBasicNode##E##P Ptr
	cur As mdBasicNode##E##P Ptr
End Type

MODULE_SCOPE Constructor mdIterator##E##P()
	
End Constructor

MODULE_SCOPE Constructor mdIterator##E##P(ByVal node As mdBasicNode##E##P Ptr)
	This.cur = node
End Constructor

MODULE_SCOPE Function mdIterator##E##P.getClass() As String
	Return UCase("mdIterator(" & #E & IIf(Len(#P), ", " & #P, "") & ")")
End Function

MODULE_SCOPE Function mdIterator##E##P.hasNext() As Boolean
	Return This.cur <> NULL
End Function

MODULE_SCOPE Function mdIterator##E##P.nex() As E P
	This.pre = This.cur
	This.cur = This.cur->nex
	Return This.pre->value
End Function

MODULE_SCOPE Sub mdIterator##E##P.remove()
	This.pre->value = This.cur->value
	This.pre->nex = This.cur->nex
	Delete This.cur
	This.cur = This.pre->nex
End Sub

#EndIf '__MDITERATOR_BI__

#EndMacro

#Define mdIteratorDeclare(E, P...) mdIteratorDeclarePtr(E, P)
