#Include Once "md/security/mdMessageDigest.bi"


Sub string_md5()
	Dim As String text = "Franz jagt im komplett verwahrlosten Taxi quer durch Bayern"
	Dim As mdMessageDigest m = mdMessageDigest.getInstance("MD5")
	m.update(text)
	Assert(m.digest() = UCase("a3cca2b2aa1e3b5b3b5aad99a8529074"))
	m.reset()
	m.update(text)
	Assert(m.digest() = UCase("a3cca2b2aa1e3b5b3b5aad99a8529074"))
	
	Dim As mdMessageDigest m1 = mdMessageDigest.getInstance("MD5")
	Assert(m1.createHash(text) = UCase("a3cca2b2aa1e3b5b3b5aad99a8529074"))
	m1.reset()
	Assert(m1.createHash(text) = UCase("a3cca2b2aa1e3b5b3b5aad99a8529074"))
End Sub
Sub string_sha1()
	Dim As String text = "Franz jagt im komplett verwahrlosten Taxi quer durch Bayern"
	Dim As mdMessageDigest m = mdMessageDigest.getInstance("SHA-1")
	m.update(text)
	Assert(m.digest() = UCase("68ac906495480a3404beee4874ed853a037a7a8f"))
	m.reset()
	m.update(text)
	Assert(m.digest() = UCase("68ac906495480a3404beee4874ed853a037a7a8f"))
	
	Dim As mdMessageDigest m1 = mdMessageDigest.getInstance("SHA-1")
	Assert(m1.createHash(text) = UCase("68ac906495480a3404beee4874ed853a037a7a8f"))
	m1.reset()
	Assert(m1.createHash(text) = UCase("68ac906495480a3404beee4874ed853a037a7a8f"))
End Sub
Sub string_sha512()
	Dim As String text = "Franz jagt im komplett verwahrlosten Taxi quer durch Bayern"
	Dim As mdMessageDigest m = mdMessageDigest.getInstance("SHA-512")
	m.update(text)
	Assert(m.digest() = UCase("af9ed2de700433b803240a552b41b5a472a6ef3fe1431a722b2063c75e9f07451f67a28e37d09cde769424c96aea6f8971389db9e1993d6c565c3c71b855723c"))
	m.reset()
	m.update(text)
	Assert(m.digest() = UCase("af9ed2de700433b803240a552b41b5a472a6ef3fe1431a722b2063c75e9f07451f67a28e37d09cde769424c96aea6f8971389db9e1993d6c565c3c71b855723c"))
	
	Dim As mdMessageDigest m1 = mdMessageDigest.getInstance("SHA-512")
	Assert(m1.createHash(text) = UCase("af9ed2de700433b803240a552b41b5a472a6ef3fe1431a722b2063c75e9f07451f67a28e37d09cde769424c96aea6f8971389db9e1993d6c565c3c71b855723c"))
	m1.reset()
	Assert(m1.createHash(text) = UCase("af9ed2de700433b803240a552b41b5a472a6ef3fe1431a722b2063c75e9f07451f67a28e37d09cde769424c96aea6f8971389db9e1993d6c565c3c71b855723c"))
End Sub
#Include "file.bi"
Sub file_md5()
	Dim As String file = ExePath & "/Lorem.txt"
	Dim As mdMessageDigest m = mdMessageDigest.getInstance("MD5")
	Assert(m.createFileHash(file) = "2CEA1C575C4971A6683318D4D4A5CB10")
	m.reset()
	Assert(m.createFileHash(file) = "2CEA1C575C4971A6683318D4D4A5CB10")
End Sub
Sub file_sha1()
	Dim As String file = ExePath & "/Lorem.txt"
	Dim As mdMessageDigest m = mdMessageDigest.getInstance("SHA-1")
	Assert(m.createFileHash(file) = "9245513D68D255D48E8702DAD636EC39F1AFC072")
	m.reset()
	Assert(m.createFileHash(file) = "9245513D68D255D48E8702DAD636EC39F1AFC072")
End Sub
Sub file_sha512()
	Dim As String file = ExePath & "/Lorem.txt"
	Dim As mdMessageDigest m = mdMessageDigest.getInstance("SHA-512")
	Assert(m.createFileHash(file) = "8ACC4A5FDD47DBB39908B4321FF876E0715581A9EB255E18C4682AF7925D3A1E186052F0FE7675D2E3E65D4ADCB9B2561F6E9F47E8E3EAC1E9C9026E2DD13C20")
	m.reset()
	Assert(m.createFileHash(file) = "8ACC4A5FDD47DBB39908B4321FF876E0715581A9EB255E18C4682AF7925D3A1E186052F0FE7675D2E3E65D4ADCB9B2561F6E9F47E8E3EAC1E9C9026E2DD13C20")
End Sub

string_md5()
string_sha1()
string_sha512()
file_md5()
file_sha1()
file_sha512()
