#Include Once "md/util/mdMap.bi"

mdMapDeclare(Long, String)


Sub constructor_empty()
	Dim As mdMap(Long, String) map
	Assert(map.toString() = "{}")
End Sub
Sub constructor_map()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	
	Dim As mdMap(Long, String) map2 = map
	Assert(map.size() = map2.size())
	Assert(map.toString() = map2.toString())
End Sub
Sub destructor_empty()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	Assert(map.size() = 1)
	map.Destructor()
	Assert(map.size() = 0)
End Sub

Sub clear_()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	Assert(map.size() = 4)
	map.clear()
	Assert(map.size() = 0)
End Sub
Sub containsKey_key()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	Assert(map.containsKey(2) = TRUE)
	Assert(map.containsKey(5) = FALSE)
End Sub
Sub containsKey_object()
	Print "containsKey_object not implemented!!!"
End Sub
Sub containsValue_object()
	Print "containsValue_object not implemented!!!"
End Sub
Sub containsValue_value()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	Assert(map.containsValue("2") = TRUE)
	Assert(map.containsValue("5") = FALSE)
End Sub
Sub entrySet()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	
	Dim As mdSet(mdMapEntry(Long, String)) set = map.entrySet()
	Assert(set.toString() = "[0=0, 1=1, 2=2, 3=3]")
End Sub
Sub equals_object()
	Print "equals_object not implemented!!!"
End Sub
Sub equals_map()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	Dim As mdMap(Long, String) map2
	temp = map2.put(0, "0")
	temp = map2.put(1, "1")
	Assert(map.equals(map2) = TRUE)
End Sub
Sub get_key()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	temp = map.put(4, "4")
	temp = map.put(5, "5")
	
	For i As Long = 0 To map.size() - 1
		Assert(Str(i) = map.get(i))
	Next
End Sub
Sub get_object()
	Print "get_object not implemented!!!"
End Sub
Sub getClass()
	Dim As mdMap(Long, String) map
	Assert(map.getClass() = UCase("mdMap(Long, String)"))
End Sub
Sub hashCode()
	Print "hashCode not implemented!!!"
End Sub
Sub isEmpty()
	Dim As mdMap(Long, String) map
	Assert(map.isEmpty() = TRUE)
	Dim As String temp = map.put(0, "0")
	Assert(map.isEmpty() = FALSE)
End Sub
Sub keySet()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	
	Dim As mdSet(Long) set = map.keySet()
	Assert(set.toString() = "[0, 1, 2, 3]")
End Sub
Sub put_()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	temp = map.put(3, "2")
	temp = map.put(4, "4")
	temp = map.put(5, "5")
	Assert(map.toString() = "{0=0, 1=1, 2=2, 3=2, 4=4, 5=5}")
End Sub
Sub putAll()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	
	Dim As mdMap(Long, String) map2
	map2.putAll(map)
	Assert(map.size() = map2.size())
	Assert(map.toString() = map2.toString())
End Sub
Sub remove_key()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	Assert(map.toString() = "{0=0, 1=1, 2=2, 3=3}")
	temp = map.remove(CLng(2))
	Assert(map.toString() = "{0=0, 1=1, 3=3}")
	temp = map.remove(CLng(0))
	Assert(map.toString() = "{1=1, 3=3}")
	temp = map.remove(CLng(1))
	Assert(map.toString() = "{3=3}")
End Sub
Sub remove_object()
	Print "remove_object not implemented!!!"
End Sub
'Sub share()
'	Dim As mdMap(Long, String) map
'	Dim As String temp = map.put(0, "0")
'	temp = map.put(1, "1")
'	temp = map.put(2, "2")
'	temp = map.put(3, "3")
'	Dim As mdMap(Long, String) map2
'	map2.share(map)
'	Assert(map.toString() = map2.toString())
'	Assert(map.equals(map2) = TRUE)
'	
'	Assert(map2.size() = 4)
'	temp = map2.remove(CLng(2))
'	Assert(map2.size() = 4)
'	temp = map.remove(CLng(2))
'	Assert(map.size() = 3)
'	Assert(map2.size() = 3)
'End Sub
Sub size()
	Dim As mdMap(Long, String) map
	Assert(map.size() = 0)
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	Assert(map.size() = 4)
	temp = map.remove(CLng(0))
	Assert(map.size() = 3)
End Sub
Sub toString()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	Assert(map.toString() = "{0=0, 1=1, 2=2, 3=3}")
End Sub
Sub values()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	temp = map.put(2, "2")
	temp = map.put(3, "3")
	
	Dim As mdCollection(String) collection = map.values()
	Assert(collection.toString() = "[0, 1, 2, 3]")
End Sub

Sub Operator_Cast_Integer()
	Dim As mdMap(Long, String) map
	Dim As Integer map_hashcode = map
	Assert(map_hashcode <> 0)
	Assert(map_hashcode = map.hashCode())
End Sub
Sub Operator_Cast_String()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	Dim As String map_string = map
	Assert(map_string = map.toString())
End Sub
Sub Operator_Let()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	Dim As mdMap(Long, String) map2
	temp = map2.put(2, "2")
	Assert(map.toString() = "{0=0, 1=1}")
	Assert(map2.toString() = "{2=2}")
	map2 = map
	Assert(map2.toString() = "{0=0, 1=1}")
End Sub
Sub Operator_equals()
	Dim As mdMap(Long, String) map
	Dim As String temp = map.put(0, "0")
	temp = map.put(1, "1")
	Dim As mdMap(Long, String) map2
	temp = map2.put(0, "0")
	Assert(map.toString() <> map2.toString())
	temp = map2.put(1, "1")
	Assert(map.toString() = map2.toString())
End Sub



constructor_empty()
constructor_map()
destructor_empty()

clear_()
containsKey_key()
'containsKey_object()
'containsValue_object()
containsValue_value()
entrySet()
'equals_object()
equals_map()
get_key()
'get_object()
getClass()
'hashCode()
isEmpty()
keySet()
put_()
putAll()
remove_key()
'remove_object()
'share()
size()
toString()
values()

Operator_Cast_Integer()
Operator_Cast_String()
Operator_Let()
Operator_equals()

